/**
 *
 */
package fr.emse.gitlab.saref.entities.tests;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

/**
 * @author Omar Qawasmeh
 *
 *
 */
@XmlRootElement(name = "testsuites")
@XmlType(propOrder = { "name", "tests", "failures", "errors", "testSuites" })
public class TestSuites implements Serializable {

	@XmlAttribute
	private String name = "";

	@XmlAttribute
	private int tests = 0;

	@XmlAttribute
	private int failures = 0;
	
	@XmlAttribute
	private int errors = 0;
	
	@XmlElement(name = "testsuite")
	private List<TestSuite> testSuites = new ArrayList<>();
	
	public TestSuites() {}
	
	public TestSuites(String name) {
		this.name = name;
	}
	
	public String getName() {
		return name;
	}

	public int getFailures() {
		return failures;
	}

	public int getErrors() {
		return errors;
	}

	public void addTestsuite(TestSuite testSuite) {
		testSuites.add(testSuite);
		tests+=testSuite.getTests();
		failures+=testSuite.getFailures();
		errors+=testSuite.getErrors();

	}
	
	public List<TestSuite> getTestSuites() {
		return testSuites;
	}

}