package fr.emse.gitlab.saref.jobs;

import java.io.File;

import org.apache.commons.io.FileUtils;

import fr.emse.gitlab.saref.Constants;
import fr.emse.gitlab.saref.Main;

public class CopyStaticFiles extends AbstractJobRunner<Void> {
	

	public CopyStaticFiles(File dir) {
		super("Copy the static files", dir);
	}
	
	@Override
	public void doJob0() {
		try {
			File siteDir = new File(directory, Constants.SITE_DIR);
			FileUtils.forceMkdir(siteDir);
			File staticDir = new File(Main.class.getClassLoader().getResource("static").getFile());
			File staticTargetDir = new File(directory, Constants.STATIC_TARGET_DIR);
			FileUtils.copyDirectory(staticDir, staticTargetDir);
		} catch(Exception ex ) {
			error("Exception while copying the static files", ex);
		}
	}

}
